/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.ModuleCreator;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.WindowConstants;
import org.visnow.vn.ModuleCreator.templates.ModuleTemplateStrings;
import org.visnow.vn.ModuleCreator.templates.XMLTemplateStrings;

/**
 *
 * @author Krzysztof S. Nowinski (University of Warsaw, ICM)
 */
public class ModuleCreatorFrame extends javax.swing.JFrame
{

    private File projectDir, packageDir, packageDirectory;
    private String packageName, moduleName, displayedName, shortDescription;

    /**
     * Creates new form ModuleCreatorFrame
     */
    public ModuleCreatorFrame()
    {
        initComponents();
        generalPanel.setParent(this);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        projectDirectoryChooser = new JFileChooser();
        packageDirectoryChooser = new JFileChooser();
        jTabbedPane1 = new JTabbedPane();
        generalPanel = new GeneralPanel();
        jPanel2 = new JPanel();
        jPanel3 = new JPanel();
        jPanel4 = new JPanel();
        finishButton = new JButton();

        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new GridBagLayout());

        jTabbedPane1.addTab("general settings", generalPanel);

        GroupLayout jPanel2Layout = new GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
                jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 395, Short.MAX_VALUE)
                );
        jPanel2Layout.setVerticalGroup(
                jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 423, Short.MAX_VALUE)
                );

        jTabbedPane1.addTab("input", jPanel2);

        GroupLayout jPanel3Layout = new GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
                jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 395, Short.MAX_VALUE)
                );
        jPanel3Layout.setVerticalGroup(
                jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 423, Short.MAX_VALUE)
                );

        jTabbedPane1.addTab("output", jPanel3);

        GroupLayout jPanel4Layout = new GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
                jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 395, Short.MAX_VALUE)
                );
        jPanel4Layout.setVerticalGroup(
                jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                        .addGap(0, 423, Short.MAX_VALUE)
                );

        jTabbedPane1.addTab("parameters", jPanel4);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        getContentPane().add(jTabbedPane1, gridBagConstraints);

        finishButton.setText("finish: generate module");
        finishButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                finishButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = GridBagConstraints.LINE_END;
        gridBagConstraints.insets = new Insets(7, 0, 0, 0);
        getContentPane().add(finishButton, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void finishButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_finishButtonActionPerformed
    {//GEN-HEADEREND:event_finishButtonActionPerformed
        createModuleClass();
        createXML();
        System.exit(0);
    }//GEN-LAST:event_finishButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                new ModuleCreatorFrame().setVisible(true);
            }
        });
    }

    protected void createModuleClass()
    {
        System.out.println(packageDirectory);
        System.out.println(packageName);
        System.out.println(moduleName);
        try {
            PrintWriter out = new PrintWriter(new File(packageDirectory.getAbsolutePath() + File.separator + moduleName + ".java"));
            out.print(ModuleTemplateStrings.getHeader(packageName, moduleName));
            out.print(ModuleTemplateStrings.getVariables());
            out.print(ModuleTemplateStrings.getConstructor(moduleName));
            out.print(ModuleTemplateStrings.getUpdateUI());
            out.print(ModuleTemplateStrings.getOnActive());
            out.println("\n}\n\n");
            out.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ModuleCreatorFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    protected void createXML()
    {
        try {
            PrintWriter outXML = new PrintWriter(new File(packageDirectory.getAbsolutePath() + File.separator + "module.xml"));
            outXML.print(XMLTemplateStrings.getHeader(displayedName, moduleName, shortDescription));
            outXML.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ModuleCreatorFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void setPackageDirectory(File packageDirectory)
    {
        this.packageDirectory = packageDirectory;
    }

    public void setProjectDir(File projectDir)
    {
        this.projectDir = projectDir;
    }

    public void setPackageName(String packageName)
    {
        this.packageName = packageName;
    }

    public void setModuleName(String moduleName)
    {
        this.moduleName = moduleName;
    }

    public void setDisplayedName(String displayedName)
    {
        this.displayedName = displayedName;
    }

    public void setShortDescription(String shortDescription)
    {
        this.shortDescription = shortDescription;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JButton finishButton;
    private GeneralPanel generalPanel;
    private JPanel jPanel2;
    private JPanel jPanel3;
    private JPanel jPanel4;
    private JTabbedPane jTabbedPane1;
    private JFileChooser packageDirectoryChooser;
    private JFileChooser projectDirectoryChooser;
    // End of variables declaration//GEN-END:variables
}
